! This is the Modula-2 run-time start-off routine.  It's job is to take the
! arguments as put on the stack by EXEC, and to parse them and set them up the
! way _m_a_i_n expects them.

.sect .text; .sect .rom; .sect .data; .sect .bss

.define m2rtso, hol0, __penvp, ___progname, __fpu_present
.sect .text
m2rtso:
	pushf
	orb	2(esp), 0x04		! turn alignment checks on
	popf
	xor	ebp, ebp		! clear for backtrace of core files
	mov	eax, (esp)		! argc
	lea	edx, 4(esp)		! argv
	lea	ecx, 8(esp)(eax*4)	! envp

	mov	(__penvp), ecx		! save envp in __penvp

	! Store argv[0] in ___progname
	mov	ebx, (edx)
	mov	(___progname), edx

	! Test if environ is in the initialized data area and is set to our
	! magic number.  If so then it is not redefined by the user.
	mov	ebx, _environ
	cmp	ebx, __edata
	jae	0f
	cmp	(ebx), 0x53535353	! is it our environ?
	jne	0f
	mov	(ebx), ecx		! environ = _penvp;
0:
	push	ecx			! push environ
	push	edx			! push argv
	push	eax			! push argc

	! Test the EM bit of the MSW to determine if an FPU is present and
	! set __fpu_present if one is found.
	smsw	ax
	testb	al, 0x4			! EM bit in MSW
	setz	al			! True if not set
	movb	(__fpu_present), al

	call	__m_a_i_n		! run Modula-2 program

	push	eax			! push exit status
	call	__exit

	hlt				! force a trap if exit fails

.sect .rom
	.data4	0			! Without -uzp, with -sep: *NULL == 0
					! Also keeps the first string in the
					! program from appearing at location 0!
.sect .data
hol0:
	.data4	0, 0
	.data4	0, 0

.sect .bss
	.comm	__penvp, 4		! Environment vector
	.comm	__fpu_present, 4	! FPU present flag
	.comm	___progname, 4		! argv[0]
