/*
syscall/_mkfifo.c

Created:	June 10, 1993 by Philip Homburg <philip@cs.vu.nl>
*/

#include <minix/stubs.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <minix/type.h>
#include <minix/callnr.h>
#include <minix/minlib.h>

int mkfifo(name, mode)
_CONST char *name;
mode_t mode;
{
	message m;

	mode = (mode & 0777) | S_IFIFO;

	m.m1_i1 = strlen(name)+1;
	m.m1_i2 = mode;
	m.m1_p1 = (char *)name;

	/* Clear unused fields */
	m.m1_i3 = 0;
	m.m1_p2 = NULL;
	m.m1_p3 = NULL;

	return _syscall(PROC_FS, MKNOD, &m);
}

/*
 * $PchId: _mkfifo.c,v 1.4 1995/11/27 19:50:04 philip Exp $
 */
